/************************************************************************

    JSWED 2.3.2 - Editor for Jet Set Willy and derivatives

    Copyright (C) 2000-2001, 2007  John Elliott <jce@seasip.demon.co.uk>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

*************************************************************************/

#include "jswed.hxx"
#include "animatespeed.hxx"


AnimateSpeed::AnimateSpeed()
{
	m_step = 1;
	m_count = 0;
}

void AnimateSpeed::slower()
{
	if (m_step == 0) return;
	if (m_step == 16) m_step = 0;
	else ++m_step;
}

void AnimateSpeed::faster()
{
	if (m_step == 1) return;
	if (m_step == 0) m_step = 16;
	else --m_step;
}

int AnimateSpeed::tick()
{
	if (m_step == 0) return 0;

	++m_count;
	if (m_count >= m_step)
	{
		m_count = 0;
		return 1;
	}
	return 0;
}

void AnimateSpeed::drawTick(VideoSurface *s, int x, int y)
{
	char buf[20];

	sprintf(buf, "Animation: %2d", m_step);
	s->drawSmallText(0, y + 63 * CHAR_SH, buf, ZX_BLACK, 
			ZX_WHITE);
}


