/************************************************************************

    JSWED 2.3.0 - Editor for Jet Set Willy and derivatives

    Copyright (C) 2000-2001,2004  John Elliott <jce@seasip.demon.co.uk>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

*************************************************************************/

#include "jswed.hxx"
#include "j48udgsform.hxx"

Jsw48UdgsForm::Jsw48UdgsForm(int count, jswByte *base, int step) : 
	VideoForm(CHAR_W + CHAR_SW, CHAR_H, CHAR_W * 37, CHAR_H * 25)
{
	int n, y, x;

	m_base  = base;
	m_count = count;
	m_step  = step;
	m_ok     = new VideoButton(ZXE_OK,     30 * CHAR_W, 21 * CHAR_H, 
						"  OK  ");
	m_cancel = new VideoButton(ZXE_CANCEL, 30 * CHAR_W, 23 * CHAR_H, 
                     				"Cancel");

	for (n = 0; n < count; n++)
	{
		if (n < 4) y = 3 * CHAR_H;
		else	   y = 15 * CHAR_H;
		x = (((n%4) * 9) + 2) * CHAR_W;
		m_edit[n] = new BitmapEditor(x, y, 8, 8, 1);
	}
}



Jsw48UdgsForm::~Jsw48UdgsForm()
{
	for (int n = 0; n < m_count; n++)
	{
		delete m_edit[n];
	}
	if (m_ok) delete m_ok;
	if (m_cancel) delete m_cancel;
}

void Jsw48UdgsForm::redraw(void)
{
	VideoForm::redraw();
	if (m_count == 7)
	{
		videoScreen->drawText(m_x + CHAR_SW, m_y + CHAR_H, "Air", ZX_BLACK, ZX_WHITE);
		videoScreen->drawText(m_x + CHAR_SW +  9*CHAR_W, m_y +      CHAR_H, "Water",    ZX_BLACK, ZX_WHITE);
		videoScreen->drawText(m_x + CHAR_SW + 18*CHAR_W, m_y +      CHAR_H, "Earth",    ZX_BLACK, ZX_WHITE);
		videoScreen->drawText(m_x + CHAR_SW + 27*CHAR_W, m_y +      CHAR_H, "Fire",     ZX_BLACK, ZX_WHITE);
		videoScreen->drawText(m_x + CHAR_SW,             m_y + 13 * CHAR_H, "Ramp",     ZX_BLACK, ZX_WHITE);
		videoScreen->drawText(m_x + CHAR_SW +  9*CHAR_W, m_y + 13 * CHAR_H, "Conveyor", ZX_BLACK, ZX_WHITE);
		videoScreen->drawText(m_x + CHAR_SW + 18*CHAR_W, m_y + 13 * CHAR_H, "Item",     ZX_BLACK, ZX_WHITE);	
		redrawBorder("Room graphics");
	}
	else
	{
		redrawBorder("Graphics");
	}
}



int Jsw48UdgsForm::doModal()
{
	return VideoForm::doModal();
}

void Jsw48UdgsForm::showChildren(int redraw)
{
        int n;
        for (n = 0; n < m_count; n++) 
	{
		addChild(m_edit[n]);
		if (n == 6) m_edit[n]->setBitmap(m_base + 10 + m_step * n);
		else	    m_edit[n]->setBitmap(m_base + m_step * n);
	}

        addChild(m_ok);
        addChild(m_cancel);
	VideoForm::showChildren(redraw);
}


void Jsw48UdgsForm::hideChildren(void)
{
        int n;
	VideoForm::hideChildren();
        for (n = 0; n < m_count; n++) removeChild(m_edit[n]);

        removeChild(m_ok);
        removeChild(m_cancel);

}

