#ifndef JSW2CELLPAGE_HXX_INCLUDED
#define JSW2CELLPAGE_HXX_INCLUDED

/************************************************************************

    JSWED 2.3.0 - Editor for Jet Set Willy and derivatives

    Copyright (C) 2000-2001,2004  John Elliott <jce@seasip.demon.co.uk>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

*************************************************************************/

#include "celllist.hxx"

class VideoCheckbox;
class VideoLabel;

class Jsw2CellPage : public VideoNotePage, SpriteListListener, 
	ColourChooserListener, CheckboxSelectListener
{
// Data
protected:
	CellList *m_list;
	BitmapEditor *m_editor;
	VideoColourChooser *m_cc[2];
	VideoCheckbox *m_cb[2];
	VideoLabel *m_lbl[4];
	Jsw2Game *m_reload;

	void undo(void);
public:
	Jsw2CellPage(Jsw2Game *g);
	virtual ~Jsw2CellPage();

	jswByte m_undoBuf[9];

	virtual int preContextMenu(void);

	virtual int onReveal(int rect);
        virtual void onChangeSprite(jswByte *newBitmap);
	virtual void onChooseColour(VideoColourChooser *c);
	virtual int onCheckboxSelect(VideoCheckbox *b, int value);

	void reload(Jsw2Game *g);
        virtual int redraw(int whichRectangle);

	virtual int onKeyDown(int keysym);
};


#endif	// def JSW2CELLPAGE_HXX_INCLUDED

