/************************************************************************

    JSWED 2.3.0 - Editor for Jet Set Willy and derivatives

    Copyright (C) 2000-2001,2004  John Elliott <jce@seasip.demon.co.uk>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

*************************************************************************/

#include "jswed.hxx"
#include "jsw2game.hxx"
#include "jsw2guard.hxx"
#include "jsw2fixedguard.hxx"

Jsw2FixedGuard::Jsw2FixedGuard(int type, SpectrumMemory *mem) :
	Jsw2HVGuardian(doConstruct(type, mem), mem)
{
}

jswByte *Jsw2FixedGuard::doConstruct(int type, SpectrumMemory *mem)
{
	static jswByte dummyGuard[7] = {0x00, 0x00, 0x06, 0x00,
					0x3C, 0x30, 0x43 };
	m_type = type;
	switch(type)
	{
		case FG_WILLY:
			dummyGuard[4] = (mem->peek(0x7533) & 0x7F) * 4;
			dummyGuard[5] = (mem->peek(0x7534));
			break;
		case FG_TOILET:
			return mem->memoryAt(0x83C9);
	}
	return dummyGuard;
}


void Jsw2FixedGuard::setPos(int x, int y)
{
	if (m_type == FG_WILLY)
	{
		m_mem->poke(0x7533, (x / 2) & 0x7F);
		m_mem->poke(0x7534, y & 0x7F);
	}
	Jsw2HVGuardian::setPos(x, y);
}
