/************************************************************************

    JSWED 2.3.0 - Editor for Jet Set Willy and derivatives

    Copyright (C) 2000-2001,2004  John Elliott <jce@seasip.demon.co.uk>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

*************************************************************************/

class Jsw2HVGuardian;
class JswDirCheckbox;

class Jsw2GuardEditor: public VideoForm, 
		      TickListener, 
		      public ButtonSelectListener,
		      public EditChangeListener, 
		      ColourChooserListener, 
	 	      public CheckboxSelectListener
{
protected:
// Drawing
	VideoBitmap	*m_bmBg;
	VideoBitmap	*m_bmAnim;
        Jsw2HVGuardian  *m_guard;
// Controls
	VideoButton 	*m_bnOk, *m_bnCancel, *m_bnSprite, *m_bnPling;
	VideoSpinControl *m_spinY, *m_spinX, *m_spinAnim, 
			 *m_spinStep1, *m_spinStep2,
			 *m_spinTick1, *m_spinTick2;
	VideoLabel       *m_labelY, *m_labelX, *m_labelAnim, *m_labelTick,
			 *m_labelDirection, *m_labelStep, *m_labelUniDir;
	VideoColourChooser *m_chInk;
	VideoCheckbox     *m_cbUniDir;
	VideoCheckbox     *m_cbDirection; 
	
// Data
	Jsw2Game	*m_game;
	jswByte		*m_gdata;
// Animation
	TickListener    *m_ot;
	int 		m_haveTick, m_tick;
	int		m_roomNo;
protected:
        void preContextMenu(void);
        void postContextMenu(void);

      	int setSprite(void); 
	void drawFixed(void);
        void drawData(int tickOnly);
	void drawTsData(void);
	void subEditChange(VideoControl *v);
	int onPling(void);
public: 
        Jsw2GuardEditor(int roomNo, Jsw2Game *g, jswByte *guard, VideoBitmap *bg);
	virtual ~Jsw2GuardEditor();
// Overrides
        void addChild(VideoControl *c);
        void removeChild(VideoControl *c);
	virtual void redraw(void);
	virtual void hideChildren(void);
	virtual void showChildren(int redraw = 1);
// Events
        virtual void onTick(void);
	virtual int onButtonSelect(VideoButton *b);
	virtual void onChooseColour(VideoColourChooser *c);
	virtual int  onCheckboxSelect(VideoCheckbox *c, int value);
	virtual void onEditChange(VideoControl *v); 
};


