/************************************************************************

    JSWED 2.3.0 - Editor for Jet Set Willy and derivatives

    Copyright (C) 2000-2001,2004  John Elliott <jce@seasip.demon.co.uk>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

*************************************************************************/

#include "jswed.hxx"
#include "jsw2msgpage.hxx"

Jsw2MessagePage::Jsw2MessagePage(SpectrumMemory *mem)
{
	int x0 = (VIDEO_W - 32 * CHAR_W - 4) / 2;
	int y0 = VIDEO_H - 6 * CHAR_H;
	int x1 = 8 * CHAR_W + CHAR_SW;
	int x2 = 8 * CHAR_W + 2;
	int n;

// "Game over" 
	m_label[0] = new VideoLabel(x1, m_y, "Game Over message");

	m_edit[0] = new VideoTextEdit( x1, m_y + 2 * CHAR_H, 
					5 * CHAR_W + 4, CHAR_H + 4);
	m_edit[0]->setLimit(4);
	m_edit[0]->bindFixed((char *)mem->memoryAt(0x7408));

	m_edit[1] = new VideoTextEdit( x1 + 6 * CHAR_W, m_y + 2 * CHAR_H,
					5 * CHAR_W + 4, CHAR_H + 4);
	m_edit[1]->setLimit(4);
	m_edit[1]->bindFixed((char *)mem->memoryAt(0x740C));

	m_label[1] = new VideoLabel(x1, m_y + 4* CHAR_H, "Game title ");

	m_edit[2] = new VideoTextEdit( x1, m_y + 6 * CHAR_H, 
					21 * CHAR_W + 4, CHAR_H + 4);	
	m_edit[2]->setLimit(21);
	m_edit[2]->bindFixed((char *)mem->memoryAt(0x73A4));

	m_label[2] = new VideoLabel(x1, m_y + 8* CHAR_H, "Press ENTER message ");
	m_edit[3] = new VideoTextEdit( x1, m_y + 10 * CHAR_H, 
					21 * CHAR_W + 4, CHAR_H + 4);	
	m_edit[3]->setLimit(20);
	m_edit[3]->bindFixed((char *)mem->memoryAt(0x73B9));

	m_label[3] = new VideoLabel(x1, m_y + 12* CHAR_H, "Items message");
	m_edit[4] = new VideoTextEdit( x1, m_y + 14 * CHAR_H, 
					12 * CHAR_W + 4, CHAR_H + 4);	
	m_edit[4]->setLimit(11);
	m_edit[4]->bindFixed((char *)mem->memoryAt(0x73EE));

	m_label[4] = new VideoLabel(x1 + 15 * CHAR_W, m_y + 12* CHAR_H, 
			"Rescue message");
	m_edit[5] = new VideoTextEdit( x1 + 15 * CHAR_W, m_y + 14 * CHAR_H, 
					15 * CHAR_W + 4, CHAR_H + 4);	
	m_edit[5]->setLimit(14);
	m_edit[5]->bindFixed((char *)mem->memoryAt(0x73F9));

	m_label[5] = new VideoLabel(x1, m_y + 16* CHAR_H, "Trip Switch off [on]");
	m_edit[6] = new VideoTextEdit( x1, m_y + 18 * CHAR_H, 
					16 * CHAR_W + 4, CHAR_H + 4);	
	m_edit[6]->setLimit(15);
	m_edit[6]->bindFixed((char *)mem->memoryAt(0x7410));

	m_label[6] = new VideoLabel(x2, y0 - CHAR_SH - 4 * CHAR_H, 
						"Status message");
	m_edit[7] = new VideoTextEdit( x0, y0 - 3 * CHAR_H, 
					34 * CHAR_W + 4, CHAR_H + 4);	
	m_edit[7]->setLimit(33);
	m_edit[7]->bindFixed((char *)mem->memoryAt(0x73CD));

	m_label[7] = new VideoLabel(x2, y0 - CHAR_SH, "Scrolling title message");

	m_edit[8] = new VideoTextEdit( x0, y0 + CHAR_H, 32*CHAR_W + 4, 
						CHAR_H + 4);
	m_edit[8]->setLimit(0x2F7);
	m_edit[8]->bindFixed((char *)mem->memoryAt(0x70AD));
	for (n = 0; n < 9; n++) addChild(m_edit[n]);
	for (n = 0; n < 8; n++) addChild(m_label[n]);
	setTitle("Message");
	setFocus(m_edit[0]);
}

Jsw2MessagePage::~Jsw2MessagePage()
{
	int n;
	for (n = 0; n < 4; n++) delete m_edit[n];
	for (n = 0; n < 3; n++) delete m_label[n];
}



int Jsw2MessagePage::redraw(int whichRectangle)
{
	int rv = VideoNotePage::redraw(whichRectangle);

	videoScreen->bottomBar("Game messages");
	return rv;
}


