/************************************************************************

    JSWED 2.3.0 - Editor for Jet Set Willy and derivatives

    Copyright (C) 2000-2001,2004-6  John Elliott <jce@seasip.demon.co.uk>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

*************************************************************************/

#include "jswed.hxx"
#include "jsw2game.hxx"
#include "room.hxx"
#include "jsw2room.hxx"
#include "jsw2splpage.hxx"
#include "jsw2roomform.hxx"
#include "jsw2cellform.hxx"
#include "jsw2guard.hxx"
#include "jsw2guardform.hxx"
#include "jsw2arrowform.hxx"
#include "jsw2targetform.hxx"

#define TOP (VIDEO_H - 224)

Jsw2SpecialPage::Jsw2SpecialPage(Jsw2Game *game) : Jsw2RoomNav(game)
{
	m_ot   = NULL;
	m_cx = m_cy = m_cyminor = m_cxminor = 0;
	m_oct = -1;
	m_oft = -1;
	m_mb = 0;
	m_ocx = m_ocy = -1;
	m_cdir = 0;
	m_undoRoom = NULL;
	int x,y,w,h;

	w = 8 * CHAR_W;
	y = TOP + 2*CHAR_H;
	x = VIDEO_W - 19 * CHAR_W;
	h = CHAR_H;

        addHotspot(new Hotspot('1', x, y, w, h, '1')); y += CHAR_H;
        addHotspot(new Hotspot('2', x, y, w, h, '2')); y += CHAR_H;
        addHotspot(new Hotspot('3', x, y, w, h, '3')); y += CHAR_H;
        addHotspot(new Hotspot('4', x, y, w, h, '4')); y += CHAR_H;

	w = 10 * CHAR_W;
	y = TOP + 2 * CHAR_H;
	x = VIDEO_W - 10 * CHAR_W;

        addHotspot(new Hotspot('5', x, y, w, h, '5')); y += CHAR_H;
        addHotspot(new Hotspot('6', x, y, w, h, '6')); y += CHAR_H;
        addHotspot(new Hotspot('7', x, y, w, h, '7')); y += CHAR_H;
        addHotspot(new Hotspot('8', x, y, w, h, '8')); y += CHAR_H;
	
        x = CHAR_W * 16;
        y = TOP + (2 * CHAR_H);
	h = CHAR_H;
	w = 11 * CHAR_W;

	addHotspot(new Hotspot('S', x, y,         w, h, 'S', 's'));
	y += h;
	addHotspot(new Hotspot('C', x, y,         w, h, 'C', 'c'));

	setTitle("Special");
	setCellType(1);
}

Jsw2SpecialPage::~Jsw2SpecialPage()
{
	if (m_undoRoom) delete m_undoRoom;
}



void Jsw2SpecialPage::drawFixed(void)
{
	int x,y,h;

	videoScreen->bottomBar("Room Specials");

	videoScreen->fillBox(VIDEO_W - 10 * CHAR_W, TOP + CHAR_H + CHAR_SH,
                                10 * CHAR_W, 5 * CHAR_H + CHAR_SH, ZX_BRWHITE);
	videoScreen->box(VIDEO_W - 10 * CHAR_W, TOP + CHAR_H,
	                                10 * CHAR_W, 6 * CHAR_H, ZX_BLACK);
	videoScreen->drawSmallText(VIDEO_W - 10 * CHAR_W, TOP + CHAR_H,
			"Teleporters             ", ZX_BRWHITE, ZX_BLACK);
	videoScreen->smallZxLogo(VIDEO_W - 6 * CHAR_SH, TOP + CHAR_H);


	videoScreen->fillBox(VIDEO_W - 19 * CHAR_W, TOP + CHAR_H + CHAR_SH,
				8 * CHAR_W, 5 * CHAR_H + CHAR_SH, ZX_BRWHITE);
	videoScreen->box(VIDEO_W - 19 * CHAR_W, TOP + CHAR_H + CHAR_SH,
				8 * CHAR_W, 5 * CHAR_H + CHAR_SH, ZX_BLACK);

        videoScreen->drawSmallText(VIDEO_W - 19 * CHAR_W, TOP + CHAR_H,
                              "Specials        ", 
				ZX_BRWHITE, ZX_BLACK);
        videoScreen->smallZxLogo(VIDEO_W - 11 * CHAR_H - 6 * CHAR_SH, 
				TOP + CHAR_H);
	videoScreen->fillBox(VIDEO_W - 13 * CHAR_W, TOP + CHAR_H + CHAR_SH, 1, 
				5 * CHAR_H + CHAR_SH, ZX_BLACK);

	x = m_x + CHAR_W * 8;
	y = TOP + CHAR_H;
	h = CHAR_H;

	videoScreen->fillBox(x - CHAR_SW, y + CHAR_SH, 25 * CHAR_SW, 3 * CHAR_H,
			ZX_BRWHITE);
        videoScreen->box(x - CHAR_SW, y + CHAR_SH, 25 * CHAR_SW, 3 * CHAR_H,
                        ZX_BLACK);

	videoScreen->drawSmallText(x - CHAR_SW,y,
			"Other options            ", ZX_BRWHITE, ZX_BLACK);
	videoScreen->drawText(x,y + h,   "S:Startroom", ZX_BLACK, ZX_BRWHITE);
	videoScreen->drawText(x,y + 2*h, "C:Cartog'y ", ZX_BLACK, ZX_BRWHITE);
	videoScreen->smallZxLogo(x + 18 * CHAR_SW, y);

	x = m_x;
	y = TOP + 9 * CHAR_H;
	videoScreen->drawSmallText(x, y, "Keyboard: ^Z or ^U to undo; CTRL+cursors", ZX_BLACK, ZX_WHITE);
	y += CHAR_SH;
	videoScreen->drawSmallText(x, y, "or J,<,> change room; cursor keys and", ZX_BLACK, ZX_WHITE);
	y += CHAR_SH;
	videoScreen->drawSmallText(x, y, "SPACE to position Willy/guardians", ZX_BLACK, ZX_WHITE);

	m_oct = -1;
	Jsw2RoomNav::drawFixed();
}


void Jsw2SpecialPage::setCellType(int ct)
{
	m_ct = ct;
	drawCellType();
}

void Jsw2SpecialPage::drawCellType()
{
	if ((m_oct == m_ct) || !m_visible || !m_drawnFixed) return;

	int w  = 10 * CHAR_W;
	int x  = VIDEO_W - w;
	int y  = TOP + 2 * CHAR_H;
	int ox = x;
	int ow = w;
	int oy = y;

	y  += (m_ct  % 10) * CHAR_H;
	oy += (m_oct % 10) * CHAR_H;

	if (m_ct  > 8) {  x -= 9 * CHAR_W;  w = 8 * CHAR_W; }
	else		  y -= CHAR_H;
	if (m_oct > 8) { ox -= 9 * CHAR_W; ow = 8 * CHAR_W; } 
	else		 oy -= CHAR_H;
	
	if (m_ct == 20)
	{
		x = m_x + CHAR_W * 8 - CHAR_SW;
		y = TOP + 3 * CHAR_H;
		w = 26 * CHAR_SW;
	}
	if (m_oct == 20)
	{
		ox = m_x + CHAR_W * 8 - CHAR_SW;
		oy = TOP + 3 * CHAR_H;
		ow = 26 * CHAR_SW;
	}

	if (m_oct >= 0) videoScreen->fillReplace (ox, oy, ow, CHAR_H,
                                        ZX_BRCYAN,
                                        ZX_BRWHITE);
	videoScreen->fillReplace(x, y, w, CHAR_H, ZX_BRWHITE,
                                        ZX_BRCYAN);
	m_oct = m_ct;


}


void Jsw2SpecialPage::flashColours(void)
{
	if (!m_visible) return;
        
	Jsw2RoomNav::flashColours();

	/* Draw guardian thumbnails */
	for (int n = 0; n < J2FG_MAX; n++)
	{
        	if (m_guards[n + GUARD_MAX]) 
			m_guards[n + GUARD_MAX]->drawThumb(videoScreen,
                                                       VIDEO_W - 12 * CHAR_W
                                                        - CHAR_SW,
                                                        TOP + (2 +n)*CHAR_H);

                else videoScreen->fillBox(VIDEO_W - 12 * CHAR_W - CHAR_SW,
                                                     TOP + (2+n) * CHAR_H,
                                                     CHAR_W, CHAR_H * (J2FG_MAX-n),
                                                     ZX_BRWHITE);
	}

	/* Draw animation frames */
        if (m_ct >= 10 && m_ct < 20 && m_guards[GUARD_MAX + (m_ct % 10)])
        {
                m_guards[GUARD_MAX + (m_ct % 10)]->drawFrames(videoScreen, 80, VIDEO_H - 32);
        }
        else    videoScreen->fillBox(80, VIDEO_H - 32, 480, 32, ZX_WHITE);

}




void Jsw2SpecialPage::drawCursor()
{
	VideoSurface *s = m_bmAnim->getSurface();
	int i = ZX_BRWHITE;
	if ((m_ticker % 20) >= 10) i = ZX_BRBLUE;

	if (m_ct == 20)	// Cartography
	{
		s->box(m_cx * 16, m_cy * 16, 16, 16, i);
	}
	else if (m_ct > 9 && m_guards[GUARD_MAX + (m_ct % 10)])
	{
		Jsw2Guardian *g = m_guards[GUARD_MAX + (m_ct % 10)];

		g->drawBounds(s,i, m_cx*8 + m_cxminor, 
				   m_cy*8 + m_cyminor);
	}
	else	// Non-existent guardian
	{	
		if (m_cx > 30) m_cx = 30;
                if (m_cy > 14) m_cy = 14;              
		s->box(m_cx * 16, m_cy * 16, 32, 32, i);
	}
}




void Jsw2SpecialPage::drawData(int flashonly)
{
	if (!flashonly)
	{
	        char s[30];

       		sprintf(s, "Room specials [%d]", m_room);
	        videoScreen->bottomBar(s);
	}
	Jsw2RoomNav::drawData(flashonly);
}



void Jsw2SpecialPage::drawGuardList(void)
{
	Jsw2Room *room = getRoom();
	int x, y, n, p, stop;
	char buf[10];
	int fg;

	y = TOP + 2 * CHAR_H;
	x = VIDEO_W - 18 * CHAR_W;
	
	stop = 0;
	for (n = 0; n < J2FG_MAX; n++)
	{
		if (m_guards[n + GUARD_MAX]) sprintf(buf, "%d:Spl", n + 1);	
		else		             sprintf(buf, "     ");

		if (n + 10 == m_ct)	p = ZX_BRCYAN;
		else			p = ZX_BRWHITE;

		videoScreen->drawText(x, y, buf, ZX_BLACK, p);
		y += CHAR_H;
	}
	y = TOP + 2 * CHAR_H;
	x = VIDEO_W - 9 * CHAR_W;
	for (n = 0; n < 4; n++)
	{
                jswByte *t = m_game->getMem()->memoryAt(0x7435 + 6 * n);
                if (t[0] == m_room)	fg = ZX_BLACK;
		else			fg = ZX_BLUE;	
		
		if (n + 1 == m_ct)	p = ZX_BRCYAN;
		else			p = ZX_BRWHITE;
			
		if (getRoom()->getT5() != 11 && getRoom()->getT5() != 22)
	        {
	              	strcpy(buf,"        "); 
	        }
		else
		{
			sprintf(buf, "%d:Tele %d", n + 5, n + 1);
		}
		videoScreen->drawText(x, y, buf, fg, p);
		y += CHAR_H;
	}
}


void Jsw2SpecialPage::drawBasic(int flashonly)
{
	char buf[3];

	Jsw2RoomNav::drawBasic(flashonly);

	if (m_game->getMem()->peek(0x7ECC) != m_room) return;
	int x, y, n;
	Room *rm = getRoom();
	jswByte *map = m_game->getMem()->memoryAt(0xFBE8);

	n = 0;
	for (y = 0; y < 16; y++) for (x = 0; x < 32; x++)
	{
		if (rm->getCellAt(x, y) == 1 && n < 129) // Water
		{
			if (map[n] >= 101)
			{
				sprintf(buf, "%d", (map[n]-1) / 100);
				m_bmRoom->getSurface()->drawSmallText
				(x * 16+1, y * 16, buf, ZX_BRWHITE, ZX_BLUE);
			}
			sprintf(buf, "%02d", (map[n]-1) % 100);
			m_bmRoom->getSurface()->drawSmallText
			(x * 16+1, y * 16 + CHAR_SH-1, buf[0], ZX_BRWHITE, ZX_BLUE);
			m_bmRoom->getSurface()->drawSmallText
			(x * 16+8, y * 16 + CHAR_SH-1, buf[1], ZX_BRWHITE, ZX_BLUE);
			++n;
		}
	}
}


int Jsw2SpecialPage::putCell()
{
	int rv;

	Jsw2Room *room = getRoom();
	int gc = room->getGuardianCount();
	int ac = room->getArrowCount();

	if (m_ct == 20)	// Cartography Room
	{
		int x1, y1, n;
		bool found;

		m_mb = 0;
		if (room->getCellAt(m_cx, m_cy) != 1) return ZXE_CONTINUE;
		n = -1;
		found = false;
		for (y1 = 0; y1 < 16; y1++) for (x1 = 0; x1 < 32; x1++)
		{
			if (found) break;
			if (room->getCellAt(x1, y1) == 1) ++n;
			if (y1 == m_cy && x1 == m_cx) found = true;
		}
		jswByte *map = m_game->getMem()->memoryAt(0xFBE8);
		if (found && n >= 0 && n < 129)
		{
			intPreContextMenu();
		        JswRoomList *s = m_game->getRoomList();
		        if (s)
		        {
		                s->setSelectedRoom(map[n] - 1);
		                s->setTitle("Cartography Cell");
		                rv = s->doModal();
		                if (rv >= ZXE_QUIT) return rv;
				postContextMenu();
				if (rv == ZXE_OK) 
				{
					map[n] = 1 + s->getSelectedRoom();
					drawBasic(false);
				}
				delete s;
			}
		}	
	}
	else if (m_ct >= 10)
	{
		Jsw2Guardian *g = m_guards[GUARD_MAX + (m_ct % 10)];

		if (g)
		{
			g->setPos(m_cx * 8 + m_cxminor,
				  m_cy * 8 + m_cyminor);
		}
	}
	else
	{
		if (getRoom()->getT5() != 11 && getRoom()->getT5() != 22)
	        {
	                return ZXE_CONTINUE;
	        }

                jswByte *t = m_game->getMem()->memoryAt(0x7435 + 6 * (m_ct - 1));
		t[0] = m_room;
		t[1] = m_cx * 4;
		t[2] = m_cy * 8;	

		intPreContextMenu();
	        JswRoomList *s = m_game->getRoomList();
	        if (s)
	        {
	                s->setSelectedRoom(t[3] - 1);
	                s->setTitle("Teleport destination");
	                rv = s->doModal();
	                if (rv >= ZXE_QUIT) return rv;
	                if (rv != ZXE_OK) return ZXE_CONTINUE;
	                t[3] = s->getSelectedRoom() + 1;
	                delete s;
	        }
		Jsw2TargetForm tf(m_game, (Jsw2Room *)(m_game->getRoomClass(t[3]-1)), t);
		rv = tf.doModal();
		postContextMenu();
		if (rv >= ZXE_QUIT) return rv;
	}
	return ZXE_CONTINUE;
}



int Jsw2SpecialPage::guardianMenu(void)
{
	Jsw2Room *room = getRoom();
	VideoMenu vmg("Guardian", "Editor", "Edit guardian", "Exit", NULL);

	int x, rv, ng, gi, bg;
	jswByte *g;

	if (m_ct < 10)		return ZXE_CONTINUE;

	rv = vmg.doModal();
        if (rv >= ZXE_QUIT) return rv;
        if (rv == ZXE_CANCEL) return ZXE_CONTINUE;
	int ns = vmg.getSelected();

	// 0 = Cancel
	// 1 = Edit
        switch(ns)
	{
		case 1: // Edit guardian
			if (m_ct < 10) return ZXE_CONTINUE;
			ng = (m_ct % 10) + GUARD_MAX;
			if (m_guards[ng])
			{
				jswByte gprev[7];
				g = m_guards[ng]->getBase();
				memcpy(gprev, g, 7);
				Jsw2GuardEditor ed(m_room, m_game, g, m_bmRoom);

				rv = ed.doModal();
				if (rv >= ZXE_QUIT) return rv;
				if (rv == ZXE_OK)
				{
// XXX This won't work for start position.
					delete m_guards[ng];
					m_guards[ng] = new Jsw2HVGuardian(g, m_game->getMem());
				}
				else
				{
					memcpy(g, gprev, 7);
				}
			}
			return ZXE_CONTINUE;
		case 2: return ZXE_OK;
	}
	return ZXE_CONTINUE;
}




int Jsw2SpecialPage::preContextMenu(void)
{
	intPreContextMenu();

	if (m_ct >= 10)
	{
		int rv = guardianMenu();
		postContextMenu();
		return rv;
	}
	return Jsw2RoomNav::preContextMenu();
}







void Jsw2SpecialPage::undo(void)
{
	Jsw2Room *b = getRoom();
	Jsw2Room buf(*b);

	if (m_undoRoom)
	{
		b->copyFrom(m_undoRoom);
		delete m_undoRoom;
	}
	m_undoRoom = new Jsw2Room(buf);

	if (m_visible) drawData();
}


void Jsw2SpecialPage::loadRoom(int room, int reload)
{
        Jsw2Room *b = (Jsw2Room *)(m_game->getRoomClass(room));

	if (!reload && b) 
	{
		if (m_undoRoom) delete m_undoRoom;
		m_undoRoom = new Jsw2Room(*b);
	}
	Jsw2RoomNav::loadRoom(room, reload);
}



int Jsw2SpecialPage::onHotspot(int id)
{
	int rv;

	if (id >= '1' && id <= '4')
	{
		if (m_guards[GUARD_MAX + (id-'1')]) setCellType(id - '1' + 10);
		return ZXE_CONTINUE;
	}
	if (id >= '5' && id <= '8')
	{
		setCellType(id - '4');
		return ZXE_CONTINUE;
	}
	if (id == 'S')	// Start room
	{
		m_game->getMem()->poke(0x752E, m_room);
		m_game->getMem()->poke(0x754B, m_room + 1);
		gotoRoom(m_room);
	}
	if (id == 'C')	// Cartography room
	{
		m_game->getMem()->poke(0x7ECC, m_room);
		gotoRoom(m_room);
		setCellType(20);
	}
	return Jsw2RoomNav::onHotspot(id);
}


int Jsw2SpecialPage::onKeyDown(int keysym)
{
	switch(keysym)
	{
		case ZXK_BREAK:
			m_ocx = m_ocy = -1;
			m_cdir  = -1;
			return ZXE_CONTINUE;
		case 'U' - '@':
		case 'Z' - '@':
			undo();
			return ZXE_CONTINUE;
		case ZXK_LEFT:
			if (m_ct >= 10)
			{
				if (m_cxminor > 1) { m_cxminor -= 2; return ZXE_CONTINUE; }
				if (m_cx > 0)      { m_cxminor = 6; --m_cx; return ZXE_CONTINUE; }
			}
			if (m_cx > 0) --m_cx;
			return ZXE_CONTINUE;
		case ZXK_RIGHT:
                        if (m_ct >= 10)
                        {
				if (m_cx == 30 && m_cxminor >= 5) return ZXE_CONTINUE;
                                if (m_cxminor < 5) { m_cxminor += 2; return ZXE_CONTINUE; }
                                if (m_cx < 30)      { m_cxminor = 0; ++m_cx; return ZXE_CONTINUE; }
                        }
			if (m_cx < 31) ++m_cx;
			return ZXE_CONTINUE;
		case ZXK_UP:
			if (m_ct >= 10)
			{
				if (m_cyminor > 0) { m_cyminor--; return ZXE_CONTINUE; }
				if (m_cy > 0)      { m_cyminor = 7; --m_cy; return ZXE_CONTINUE; }
			}
			if (m_cy > 0) --m_cy;
			return ZXE_CONTINUE;
		case ZXK_DOWN:
                        if (m_ct >= 10)
                        {
				if (m_cy == 14 && m_cyminor >= 6) return ZXE_CONTINUE;
                                if (m_cyminor < 7) { m_cyminor++; return ZXE_CONTINUE; }
                                if (m_cy < 15)      { m_cyminor = 0; ++m_cy; return ZXE_CONTINUE; }
                        }
			if (m_cy < 15) ++m_cy;
			return ZXE_CONTINUE; 
		case ZXK_ENTER:
		case ' ': 
			 return putCell(); 
	}
	return Jsw2RoomNav::onKeyDown(keysym);
}

int Jsw2SpecialPage::onButtonDown(int x, int y, int button)
{
	if (y >= m_y + Y_OFFSET && y < (m_y + 256 + Y_OFFSET) &&
            x >= m_x + X_OFFSET && x < (m_x + 512 + X_OFFSET))
	{
		m_mb = 1;
		return onMouseMove(x, y, 0, 0);
	}
	return Jsw2RoomNav::onButtonDown(x, y, button);
}

int Jsw2SpecialPage::onButtonUp(int x, int y, int button)
{
	m_mb = 0;
	return Jsw2RoomNav::onButtonUp(x, y, button);
}

int Jsw2SpecialPage::onMouseMove(int x, int y, int xrel, int yrel)
{
	if (y >= m_y + Y_OFFSET && y < (m_y + 256 + Y_OFFSET) &&
            x >= m_x + X_OFFSET && x < (m_x + 512 + X_OFFSET))
	{
		m_cx = (x - X_OFFSET - m_x)/16;
		m_cy = (y - Y_OFFSET - m_y)/16;
		m_cyminor = ((y - Y_OFFSET - m_y) % 16) / 2;
		m_cxminor = (((x - X_OFFSET - m_x) % 16) / 4) * 2;
		if (m_mb) return putCell();
	}
	return ZXE_CONTINUE;
}





