/************************************************************************

    JSWED 2.3.0 - Editor for Jet Set Willy and derivatives

    Copyright (C) 2000-2001,2004 John Elliott <jce@seasip.demon.co.uk>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

*************************************************************************/

#include "hotspotmgr.hxx"

struct SDL_Surface;

class JswTitlePage : public VideoNotePage, 
                      public TickListener, 
                      public HotspotManager
{
protected:
        VideoBitmap   *m_bmAttr1, *m_bmAttr2, *m_bmTick;
	jswByte       *m_attrs;
	SpectrumMemory *m_mem;
	jswByte       m_undoAttrs[512];

	bool m_bDraw;
	int  m_buttonDown;
	jswByte m_attrib;
	int  m_w, m_h, m_aw, m_ah, m_format, m_acx, m_acy, m_visible;
	int  m_tcount, m_haveTimer, m_mode, m_pcx, m_pcy;
	TickListener *m_ot;
	void intPreContextMenu();
	void setup(bool withUndo = true);
	void deleteBitmaps(bool withUndo = true);
	void setCellAttribute(int x, int y, int attr = -1);
	jswByte getCellAttribute(int x, int y);
	jswByte get8Pixels(int x, int y);
	void drawData(int tickOnly);
	void drawCursor(void);
	void drawCell(int x, int y);
	void moveCursor(int x, int y);
	virtual void showAttributes(void);
	void onDraw(void);
	virtual int onUndo(void);

	virtual int getCell(int x, int y, jswByte *attr, jswByte **pStripe);
	virtual void putCell(int x, int y, jswByte attr);
	virtual jswByte *getUdgs() = 0;
	virtual int setupColours() = 0;

	int doImport(void);
	int doExport(void);

	int importScreen(FILE *fp);
	void importCell(int x, int y, SDL_Surface *s0);
	int importImage(char *filename);

	int exportScreen(void);
	int exportPNG(void);

	int m_imgLen;
public:
	JswTitlePage(jswByte *image, int len);
	virtual ~JswTitlePage();
// Events
	virtual void onTick(void);
	virtual int  onKeyDown(int keysym);	
	virtual int  onMouseMove(int x, int y, int xrel, int yrel);
	virtual int  onButtonDown(int x, int y, int button);
	virtual int  onButtonUp  (int x, int y, int button);
// Overrides
        virtual int redraw(int whichRectangle);
	virtual int preContextMenu(void);
	virtual void postContextMenu(void);
	virtual int onReveal(int whichRectangle);
	virtual int onConceal(void);
	virtual int onHotspot(int id);
};


