
/************************************************************************

    JSWED 2.3.0 - Editor for Jet Set Willy and derivatives

    Copyright (C) 2000-2001,2004  John Elliott <jce@seasip.demon.co.uk>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

*************************************************************************/

#include "jswed.hxx"
#include "manicgame.hxx"
#include "manicattrpage.hxx"
#include "manic128game.hxx"
#include "manic128attrpage.hxx"

Manic128AttrPage::Manic128AttrPage(Manic128Game *g) : ManicAttrPage(g)
{
	m_game = g;

	setTitle("Screens");

	setup(BM_BOTTOMSCR);
}


Manic128AttrPage::~Manic128AttrPage()
{
}

#include "maniclives.xbm"


void Manic128AttrPage::setup(int bitmap)
{	
	m_nBitmap = bitmap;
	switch(bitmap)
	{
		case BM_BOTTOMSCR:	m_bits   = maniclives_bits;
					m_attrs  = m_game->getScreenBuffer() + 0x1A00;
					m_format = FMT_XBM;
					m_w      = maniclives_width;
					m_h      = maniclives_height;
					break;
		case BM_TITLE1:		m_bits   = m_game->getScreenBuffer();
					m_attrs  = m_game->getScreenBuffer() + 0x1800;
					m_format = FMT_SCREEN;
					m_w      = 256;
					m_h      = 64;
					break;	
		case BM_TITLE2:		m_bits   = m_game->getScreenBuffer() + 0x800;
					m_attrs  = m_game->getScreenBuffer() + 0x1900;
                                        m_format = FMT_SCREEN;
                                        m_w      = 256;
                                        m_h      = 64;
                                        break;

		case BM_LOADSCR:	m_bits   = m_game->getMem()->memoryAt(0x4000);
					m_attrs  = m_game->getMem()->memoryAt(0x5800);
					m_format = FMT_SCREEN;
					m_w       = 256;
					m_h       = 192;
					break;
	}	
	ScreenEditorPage::setup();
}


