#ifndef MANIC128GAME_HXX_INCLUDED
#define MANIC128GAME_HXX_INCLUDED 

/************************************************************************

    JSWED 2.3.0 - Editor for Jet Set Willy and derivatives

    Copyright (C) 2000-2001,2004  John Elliott <jce@seasip.demon.co.uk>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

*************************************************************************/

class ProgressForm;

class Manic128Game : public ManicGame
{
public:
	Manic128Game(SpectrumMemory *mem);
	virtual ~Manic128Game();

        virtual char *getID();

	virtual unsigned short xltAddress(unsigned short address);
	virtual int compress();
	virtual int decompress();
	virtual void fillSprites(int room, SpriteList *s, int every);
	virtual void addPages(VideoNotebook *n);

	virtual jswByte *getRoom(int room);
        virtual char *getTitleMessage();
	inline jswByte *getScreenBuffer() { return m_screenBuffer; }
	virtual jswByte *getRoomTitleAttrs(void);

protected:
	void expandRoom(int room, jswByte *buffer);
	void expandData(jswByte *compressed, jswByte *uncomp, unsigned len);
	unsigned compressData(jswByte *uncomp, jswByte *compressed, unsigned len, ProgressForm *pf);
	void compChunk(jswByte *uncomp, jswByte *comp, unsigned *soFar, unsigned *destOffset, jswByte rleByte, unsigned remaining);
private:
	jswByte m_roomBuffer[20480];
	jswByte m_screenBuffer[6912];
};

#endif // ndef MANIC128GAME_HXX_INCLUDED
