/************************************************************************

    JSWED 2.3.0 - Editor for Jet Set Willy and derivatives

    Copyright (C) 2000-2001,2004  John Elliott <jce@seasip.demon.co.uk>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

*************************************************************************/

#include "jswed.hxx"
#include "manicgame.hxx"
#include "manicpatchpage.hxx"
#include "manic128patchpage.hxx"
#include "filetypelist.hxx"
#include "patch.hxx"

PatchLine plSpecialsAnywhwere128[] = {
		{0x872C, 0x3A, 0xCD}, /* Border colour */
		{0x872D, 0x73, 0xFD},
		{0x872E, 0x80, 0x95},

		{0x87A0, 0x07, 0x73}, /* Eugene check */
		{0x87A1, 0x84, 0x80},
		{0x87A2, 0xFE, 0xE6},
		{0x87A3, 0x04, 0x80},
		{0x87A4, 0xCC, 0xC4},

		{0x87A8, 0x07, 0x73}, /* Skylab check */
		{0x87A9, 0x84, 0x80},
		{0x87AA, 0xFE, 0xE6},
		{0x87AB, 0x0D, 0x40},
		{0x87AC, 0xCA, 0xC2},

		{0x87B0, 0x07, 0x73}, /* Vertical guard check */
		{0x87B1, 0x84, 0x80},
		{0x87B2, 0xFE, 0xE6},
		{0x87B3, 0x08, 0x20},
		{0x87B4, 0xD4, 0xC4},

		{0x87B8, 0x07, 0x73}, /* Kong check */
		{0x87B9, 0x84, 0x80},
		{0x87BA, 0xFE, 0xE6},
		{0x87BB, 0x07, 0x10},
		{0x87BC, 0xCC, 0xC4},

		{0x87C0, 0x07, 0x73}, /* Solar Power check (previously Kong II) */
		{0x87C1, 0x84, 0x80},
		{0x87C2, 0xFE, 0xE6},
		{0x87C3, 0x0B, 0x08},
		{0x87C4, 0xCC, 0xC4},
		{0x87C5, 0x54, 0x73},
		{0x87C6, 0x91, 0x8D},
		{0x87C7, 0x3A, 0x00}, /* Old Solar power check */
		{0x87C8, 0x07, 0x00}, 
		{0x87C9, 0x84, 0x00},
		{0x87CA, 0xFE, 0x00},
		{0x87CB, 0x12, 0x00},
		{0x87CC, 0xCC, 0x00},
		{0x87CD, 0x92, 0x00},
		{0x87CE, 0x8D, 0x00},

		{0x8B00, 0x3A, 0xCD}, /* Border colour */
		{0x8B01, 0x73, 0xFD},
		{0x8B02, 0x80, 0x95},

		{0x8B7B, 0x3A, 0xCD}, /* Border colour */
		{0x8B7C, 0x73, 0xFD},
		{0x8B7D, 0x80, 0x95},

		{0x8DF2, 0x07, 0x73}, /* Check for bidirectional guardians */
		{0x8DF3, 0x84, 0x80},
		{0x8DF4, 0xFE, 0xE6},
		{0x8DF5, 0x07, 0x30},
		{0x8DF6, 0x38, 0x28},
		{0x8DF8, 0xFE, 0xCB},
		{0x8DF9, 0x09, 0xFB},
		{0x8DFA, 0x28, 0x00},
		{0x8DFB, 0x06, 0x00},
		{0x8DFC, 0xFE, 0x00},
		{0x8DFD, 0x0F, 0x00},
		{0x8DFE, 0x28, 0x00},
		{0x8DFF, 0x02, 0x00},
		{0x8E00, 0xCB, 0x00},
		{0x8E01, 0xFB, 0x00},

		{0x91D1, 0x3A, 0xCD}, /* Border colour */
		{0x91D2, 0x73, 0xFD},
		{0x91D3, 0x80, 0x95},

		{0x95FD, 0x00, 0x3A},
		{0x95FE, 0x00, 0x73},
		{0x95FF, 0x00, 0x80},
		{0x9600, 0x00, 0xE6},
		{0x9601, 0x00, 0x07},
		{0x9602, 0x00, 0xC9}
};


Patch patchSpecialsAnywhere128 = { NULL, NULL,  
	sizeof(plSpecialsAnywhwere128) / sizeof(plSpecialsAnywhwere128[0]),
	plSpecialsAnywhwere128 };


Manic128PatchPage::Manic128PatchPage(ManicGame *g) : ManicPatchPage(g)
{
	int y = 7 * CHAR_H + 2;
	int x = 9 * CHAR_W;
	int n;

	/* Done by base class 
	int x, y;
	m_game = g;

	x = 9 * CHAR_W;
	y = CHAR_H;

	m_fflabel = new VideoLabel(x, y, "File format:");

	m_fflist = new FileTypeList((jswByte *)&m_game->getMem()->m_type, 
				x + 13 * CHAR_W, y, 8 * CHAR_W, 6*CHAR_H);
	m_fflist->setTitle("");
	m_fflist->requireClick(1);

	setTitle("Game");
	addChild(m_fflabel);
	addChild(m_fflist);
	setFocus(m_fflist);

	y += 6 * CHAR_H + 2;
	*/

	// Delete any patches added by the base class
	for (n = 0; n < m_patchCount; n++)	
	{
		delete m_patchData[n].label;
		delete m_patchData[n].checkbox;
	}	
	delete m_patchData; 

	m_patchData = new Patch[20];
	m_patchCount = 0;
	m_patchMax = 20;

	// Add the patches 
	patchSpecialsAnywhere128.label    = new VideoLabel(x, y, "Specials by room");
	patchSpecialsAnywhere128.checkbox = new VideoCheckbox(x + 21 * CHAR_W, y);
	addPatch(&patchSpecialsAnywhere128);

	y += CHAR_H + 4;
	updatePatches();

}

Manic128PatchPage::~Manic128PatchPage()
{	
// Done by base class
/*	int n;
	delete m_fflabel;
	delete m_fflist;

	for (n = 0; n < m_patchCount; n++)	
	{
		delete m_patchData[n].label;
		delete m_patchData[n].checkbox;
	}	
	delete m_patchData; */
}

