
Name "Jet Set Willy Editor"
OutFile "jswed233.exe"
InstallDir $PROGRAMFILES\JSWED2
;InstalDirRegKey HKLM "Software\jce@seasip\JSWED" "Install_Dir"

; Pages

Page components
Page directory
Page instfiles

UninstPage uninstConfirm
UninstPage instfiles

; Files to install

Section "Programs"
  SectionIn RO
  SetOutPath $INSTDIR
  File "../jswed.exe"
  File "../SDL.dll"
  File "../copying.txt"
  SetOutPath $INSTDIR\share
  File "../share/jswed.png"
  File "../share/fileicons.png"
  File "../share/jswed.ico"
  File "../share/jswed_logo.png"
  File "../share/room_v.hex"
  File "../share/room_w.hex"
  File "../share/room_x.hex"
  File "../share/room_y.hex"
  File "../share/room_yy.hex"
  File "../share/room_z.hex"
  File "../share/rtime7v.bin"
  File "../share/rtime7w.bin"
  File "../share/rtime7x.bin"
  File "../share/rtime7y.bin"
  File "../share/rtime7yy.bin"
  File "../share/rtime7z.bin"
  File "../share/COPYING"
  SetOutPath $INSTDIR
  WriteRegStr HKLM SOFTWARE\jce@seasip\JSWED "Install_Dir" "$INSTDIR"
  WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\JSWED" "DisplayName" "Jet Set Willy Editor" 
  WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\JSWED" "UninstallString" "$INSTDIR\uninstall.exe" 
  WriteRegDWORD HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\JSWED" "NoModify" 1
  WriteRegDWORD HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\JSWED" "NoRepair" 1
  WriteUninstaller "uninstall.exe"

; Start menu shortcuts
  CreateDirectory "$SMPROGRAMS\Jet Set Willy Editor"
  CreateShortCut "$SMPROGRAMS\Jet Set Willy Editor\Uninstall.lnk" "$INSTDIR\uninstall.exe" "" "$INSTDIR\uninstall.exe" 0
  CreateShortCut "$SMPROGRAMS\Jet Set Willy Editor\Jet Set Willy Editor.lnk" "$INSTDIR\jswed.exe" "" "$INSTDIR\share\jswed.ico" 0
SectionEnd

Section "Source code"
  SetOutPath $INSTDIR
  File "../jswed-2.3.3.tar.gz"

SectionEnd

Section "Documentation"
  SetOutPath $INSTDIR
  File "../jswed.pdf"
  File "../jswed.txt"
  CreateShortCut "$SMPROGRAMS\Jet Set Willy Editor\Documentation.lnk" "$INSTDIR\jswed.pdf" "" "$INSTDIR\jswed.pdf" 0
SectionEnd

; Uninstaller
Section "Uninstall"
  ; Clean registry
  DeleteRegKey HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\JSWED"
  DeleteRegKey HKLM SOFTWARE\jce@seasip\JSWED
  ; Remove programs
  Delete $INSTDIR\jswed.exe
  Delete $INSTDIR\SDL.dll
  Delete $INSTDIR\copying.txt
  Delete $INSTDIR\jswed.txt
  Delete $INSTDIR\jswed.pdf
  Delete $INSTDIR\share\jswed.png
  Delete $INSTDIR\share\jswed.ico
  Delete $INSTDIR\share\fileicons.png
  Delete $INSTDIR\share\jswed_logo.png
  Delete $INSTDIR\share\room_v.hex
  Delete $INSTDIR\share\room_w.hex
  Delete $INSTDIR\share\room_x.hex
  Delete $INSTDIR\share\room_y.hex
  Delete $INSTDIR\share\room_yy.hex
  Delete $INSTDIR\share\room_z.hex
  Delete $INSTDIR\share\rtime7v.bin
  Delete $INSTDIR\share\rtime7w.bin
  Delete $INSTDIR\share\rtime7x.bin
  Delete $INSTDIR\share\rtime7y.bin
  Delete $INSTDIR\share\rtime7yy.bin
  Delete $INSTDIR\share\rtime7z.bin
  Delete $INSTDIR\share\COPYING
  Delete $INSTDIR\jswed-2.3.3.tar.gz
  Delete $INSTDIR\uninstall.exe
  ; Remove shortcuts
  Delete "$SMPROGRAMS\Jet Set Willy Editor\*.*"
  ; Remove directories
  RMDir "$SMPROGRAMS\Jet Set Willy Editor"
  RMDir "$INSTDIR\share"
  RMDir "$INSTDIR"

SectionEnd

